
#include "adt.h"
#include "lop.h"

#include <stdio.h>
#include <memory.h>

/*
void WaitForTwenty()
{
    static int cnn = 0;
    int a;
    if(!(++cnn % 20))
       a = getc(stdin);
}
*/

void PrintVertex(INDEX_TYPE _i, vertex* v)
{
    printf("%d : %f %f %f\n", _i, v->x, v->y, v->z);
}



double EvalPolinom(vertex* _p, vertex* _point)
{
        return _p->x*_point->x+_p->y*_point->y+_p->z;
}

double Sarlus( vertex* _v1, vertex* _v2, vertex* _v3)
{
        double t1;
        double t2;
	/*
	t1= _v1->x*(_v2->y*_v3->z-_v3->y*_v2->z)-
	  _v1->y*(_v2->x*_v3->z-_v3->x*_v2->z)+
	  _v1->z*(_v2->x*_v3->y-_v3->x*_v2->y);
	return t1;
	*/

        t1 = _v1->x*_v2->y*_v3->z + _v1->y*_v2->z*_v3->x + _v1->z*_v2->x*_v3->y;
        t2 = _v1->z*_v2->y*_v3->x + _v1->y*_v2->x*_v3->z + _v1->x*_v2->z*_v3->y;

        return t1-t2;
}
/*
void CartToBaric( vertex* _v1, vertex* _v2, vertex* _v3, vertex* _v4, vertex* _dest)
{
        vertex pV[4];
        double d;

        memcpy( &pV[0], _v1, sizeof(vertex) );
        memcpy( &pV[1], _v2, sizeof(vertex) );
        memcpy( &pV[2], _v3, sizeof(vertex) );
        memcpy( &pV[3], _v4, sizeof(vertex) );

        // Imposta la stessa profondit
        pV[0].z = 1.0;
        pV[1].z = 1.0;
        pV[2].z = 1.0;
        pV[3].z = 1.0;

        d = (Sarlus(&pV[0], &pV[1], &pV[2]));

        if(d==0)
        {
                _dest->x = -1;
                return;
        }

        _dest->x = (float)(Sarlus(&pV[0], &pV[3], &pV[2])) / d;
        _dest->y = (float)(Sarlus(&pV[1], &pV[3], &pV[2])) / d;
        _dest->z = (float)(Sarlus(&pV[0], &pV[3], &pV[1])) / d;
}

int IsConvex( hedge* _ed )
{
        vertex pV[4];
        vertex* pE[4];
        hedge* tE;

        pE[0] = &m->avertex[_ed->ipoint].ver;
        tE = &m->aedge[_ed->inext];
        pE[1] = &m->avertex[tE->ipoint].ver;
        tE = &m->aedge[tE->inext];
        pE[2] = &m->avertex[tE->ipoint].ver;
        tE = &m->aedge[_ed->isibl];
        tE = &m->aedge[tE->inext];
        tE = &m->aedge[tE->inext];
        pE[3] = &m->avertex[tE->ipoint].ver;


        CartToBaric(pE[0], pE[1], pE[2], pE[3], &pV[0]);
        CartToBaric(pE[1], pE[2], pE[3], pE[0], &pV[1]);
        CartToBaric(pE[2], pE[3], pE[0], pE[1], &pV[2]);
        CartToBaric(pE[3], pE[0], pE[1], pE[2], &pV[3]);


        if ( pV[0].x>=0 && pV[0].y>=0 && pV[0].z>=0)
                return 0;

        if ( pV[1].x>=0 && pV[1].y>=0 && pV[1].z>=0)
                return 0;

        if ( pV[2].x>=0 && pV[2].y>=0 && pV[2].z>=0)
                return 0;

        if ( pV[3].x>=0 && pV[3].y>=0 && pV[3].z>=0)
                return 0;

        return 1;

}*/


int SGN(float _a)
{
    return ((_a<0) ? -1 : 1);
}


vertex& VertexPoint(mesh* _msh, INDEX_TYPE _idx)
{
    return _msh->avertex[_idx].ver;
}


INDEX_TYPE EdgePoint(mesh* _msh, INDEX_TYPE _idx)
{
    return _msh->aedge[_idx].ipoint;
}


INDEX_TYPE EdgeNext(mesh* _msh, INDEX_TYPE _idx)
{
    return _msh->aedge[_idx].inext;
}

INDEX_TYPE EdgeSibl(mesh* _msh, INDEX_TYPE _idx)
{
    return _msh->aedge[_idx].isibl;
}



int LOP_OneStep(mesh* _msh, INDEX_TYPE _idx, CriteriaFunc _cf)
{
    INDEX_TYPE a, b, c, d;
    vertex p1;
    vertex p2;
    vertex p3;
    vertex p4;
    vertex pt1;
    vertex pt2;

    // Have sibling??
    if(EdgeSibl(_msh, _idx) == -1)
        return 0;

    a = EdgePoint(_msh, _idx);
    b = EdgePoint(_msh, EdgeNext(_msh, _idx));
    c = EdgePoint(_msh, EdgeNext(_msh, EdgeNext(_msh, _idx)));
    d = EdgePoint(_msh, EdgeNext(_msh, EdgeNext(_msh, EdgeSibl(_msh, _idx))));

    p1 = VertexPoint(_msh, a);
    p2 = VertexPoint(_msh, c);
    p3 = VertexPoint(_msh, d);
    p4 = VertexPoint(_msh, b);

    p1.z = 0.0;
    p2.z = 0.0;
    p3.z = 0.0;
    p4.z = 0.0;

    pt1 = p1 - p2;
    pt2 = p3 - p1;

    p1 = prod_vett(pt1, pt2 );

    pt1 = p4 - p2;
    pt2 = p3 - p4;

    p2 = prod_vett(pt1, pt2 );

    // Convex....
    if (SGN(p1.z) == SGN(p2.z))
        return 0;


        /*if(!IsConvex(&m->aedge[_idx]))
                return 0;*/

    if( _cf(_msh, a, b, c, d) )
      {
        OperateFlip(_msh, _idx);
	return 1;
      }
    return 0;
}


void LOP(mesh* _msh, CriteriaFunc _fnc)
{
    int i = 0;
    int flag = 1;
    int ct=0;

    printf("\nLOP:");
    
    while(flag && ct <100)
      {
        flag = 0;
        
	for(i=0; i< _msh->nedge; i++)
	  {
	    if(LOP_OneStep(_msh, i, _fnc))
	      flag=1;
	    
	  }
	ct++;

	printf("*");
	fflush(stdout);
    }
    printf("\n");
}


int CrDoNothing(mesh* _msh, INDEX_TYPE _p1,INDEX_TYPE _p2, INDEX_TYPE _p3, INDEX_TYPE _p4)
{
    return 1;
}

int CrABNCriteria(mesh* _msh, INDEX_TYPE _p1,INDEX_TYPE _p2, INDEX_TYPE _p3, INDEX_TYPE _p4)
{
        double A1, A2;
	double tmp1, tmp2;

        vertex pV[4];

        Interpola(_msh, _p1, _p2, _p3, &pV[0]);
        Interpola(_msh, _p1, _p2, _p4, &pV[1]);

        Interpola(_msh, _p2, _p3, _p4, &pV[2]);
        Interpola(_msh, _p3, _p1, _p4, &pV[3]);
	
        pV[0].z = -1.0;
        pV[1].z = -1.0;
        pV[2].z = -1.0;
        pV[3].z = -1.0;

	pV[0].normalize();
	pV[1].normalize();
	pV[2].normalize();
	pV[3].normalize();

        A1 = (pV[0] * pV[1]);
        A2 = (pV[2] * pV[3]);
	
        if (A1<A2)
                return 1;

        return 0;
}


int CrDLPCriteria(mesh* _msh, INDEX_TYPE _p1,INDEX_TYPE _p2, INDEX_TYPE _p3, INDEX_TYPE _p4)
{
        double A1, A2, A3, A4;
        vertex pV[4];

        Interpola(_msh, _p1, _p2, _p3, &pV[0]);
        Interpola(_msh, _p1, _p2, _p4, &pV[1]);

        Interpola(_msh, _p2, _p3, _p4, &pV[2]);
        Interpola(_msh, _p3, _p1, _p4, &pV[3]);
	


        A1 = EvalPolinom(&pV[0], &_msh->avertex[_p4].ver)-_msh->avertex[_p4].ver.z;
        A2 = EvalPolinom(&pV[1], &_msh->avertex[_p3].ver)-_msh->avertex[_p3].ver.z;

        A3 = EvalPolinom(&pV[2], &_msh->avertex[_p1].ver)-_msh->avertex[_p1].ver.z;
        A4 = EvalPolinom(&pV[3], &_msh->avertex[_p2].ver)-_msh->avertex[_p2].ver.z;

        // Norma 1 matriciale
        A1 = fabs(A1)+fabs(A2);
        A2 = fabs(A3)+fabs(A4);

        //A1=sqrt(A1*A1+A2*A2);
        //A2=sqrt(A3*A3+A4*A4);


        // Norma inf
        //A1 = max(A1,A2);
        //A2 = max(A3,A4);

        if (A1>A2)
	  return 1;

        return 0;
}

vertex Find_Normal(mesh* _msh, INDEX_TYPE _p1,INDEX_TYPE _p2)
{
        vertex t1 = VertexPoint(_msh, EdgePoint(_msh, _p1));
        vertex t2 = VertexPoint(_msh, EdgePoint(_msh, _p2));
        vertex tmp;
    tmp = t2 - t1;
    if (tmp.x != 0)
    {
            tmp.x = -1.0/tmp.x*tmp.y;
        tmp.y = 1.0;
        tmp.z = 0.0;
    }
    else
    {
        tmp.x = 1.0;
        tmp.y = 0.0;
        tmp.z = 0.0;
    }
    return tmp.normalize();
}


int CrJNDCriteria(mesh* _msh, INDEX_TYPE _p1,INDEX_TYPE _p2, INDEX_TYPE _p3, INDEX_TYPE _p4)
{
        double A1, A2;
        vertex pV[6];
        vertex tmp1;
        vertex tmp2;
	Interpola(_msh  , _p1, _p2, _p3, &pV[0]);
        Interpola(_msh  , _p1, _p2, _p4, &pV[1]);

        Interpola(_msh  , _p2, _p3, _p4, &pV[2]);
        Interpola(_msh  , _p3, _p1, _p4, &pV[3]);


        tmp1 = Find_Normal(_msh, _p1, _p2);
        tmp2 = Find_Normal(_msh, _p3, _p4);

        pV[0] = pV[1] - pV[0];
        pV[2] = pV[3] - pV[2];

        A1=fabs(tmp1.x*pV[0].x+tmp1.y*pV[0].y);
        A2=fabs(tmp2.x*pV[2].x+tmp2.y*pV[2].y);

        //A1 = fabs(pV[4].x*(pV[0].x-pV[1].x)+pV[4].y*(pV[0].y-pV[1].y));
        //A2 = fabs(pV[5].x*(pV[2].x-pV[3].x)+pV[5].y*(pV[2].y-pV[3].y));

        if (A1>A2)
                        return 1;

        return 0;
}

void Interpola( vertex* v1, vertex* v2, vertex* v3, vertex* inter)
{
        double g, t, c, det ;
        vertex pV[4];

        memcpy( &pV[0], v1, sizeof(vertex));
        memcpy( &pV[1], v2, sizeof(vertex));
        memcpy( &pV[2], v3, sizeof(vertex));

        c = Sarlus(&pV[0],&pV[1], &pV[2]);

        pV[0].z = 1.0;
        pV[1].z = 1.0;
        pV[2].z = 1.0;

        det = Sarlus(&pV[0],&pV[1], &pV[2]);

        pV[0].x = v1->z;
        pV[1].x = v2->z;
        pV[2].x = v3->z;
	
        inter->x = Sarlus(&pV[0],&pV[1], &pV[2]) / det;

        pV[0].x = v1->x;
        pV[1].x = v2->x;
        pV[2].x = v3->x;

        pV[0].y = v1->z;
        pV[1].y = v2->z;
        pV[2].y = v3->z;

        inter->y = Sarlus(&pV[0],&pV[1], &pV[2]) / det;
        inter->z = c / det;
}

void Interpola(mesh* _msh, INDEX_TYPE _a, INDEX_TYPE _b, INDEX_TYPE _c, vertex* _v)
{
    vertex* p1 = &_msh->avertex[_a].ver;
    vertex* p2 = &_msh->avertex[_b].ver;
    vertex* p3 = &_msh->avertex[_c].ver;

        Interpola(p1, p2, p3, _v);
        _v->normalize();
}


void OperateFlip(mesh* _msh, INDEX_TYPE _idx)
{
    INDEX_TYPE idx[5];
    INDEX_TYPE iface;
    hedge* pEdg;

    idx[0] = EdgeNext(_msh, _idx);
    idx[1] = EdgeNext(_msh, idx[0]);
    idx[2] = EdgeSibl(_msh, _idx);
    idx[3] = EdgeNext(_msh, idx[2]);
    idx[4] = EdgeNext(_msh, idx[3]);

    // face one
    pEdg = &_msh->aedge[_idx];
    pEdg->inext = idx[1];
    pEdg->ipoint = EdgePoint(_msh, idx[4] );
    iface = pEdg->iface;


    pEdg = &_msh->aedge[idx[1]];
    pEdg->inext = idx[3];
    pEdg->iface = iface;

    pEdg = &_msh->aedge[idx[3]];
    pEdg->inext = _idx;
    pEdg->iface = iface;

    _msh->aface[iface].iedge = _idx;

    // face two
    pEdg = &_msh->aedge[idx[2]];
    pEdg->inext = idx[4];
    pEdg->ipoint = EdgePoint(_msh, idx[1] );
    iface = pEdg->iface;

    pEdg = &_msh->aedge[idx[4]];
    pEdg->inext = idx[0];
    pEdg->iface = iface;

    pEdg = &_msh->aedge[idx[0]];
    pEdg->inext = idx[2];
    pEdg->iface = iface;

    _msh->aface[iface].iedge = idx[2];
}
