#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <assert.h>
#include <string.h>

#include <GL/glut.h>
#include "lop.h"
#include "adt.h"
#include "triio.h"
#include "integral.h"

int sizex=500,sizey=500; //screen
GLfloat luce0[4];
GLfloat xrot,yrot,zrot;
GLfloat zoom;
GLfloat xtrasl,ytrasl,ztrasl;
GLfloat startx,starty;
GLfloat* id, * matrix;
GLfloat* rot,* rot1,* rot2,* rot3; //matrice per le rotazioni
int i,j,k;
int moving;
int step=0;

int cnt=0;

int original=0;

int suddx,suddy;
int lines=0;


mesh* m;
mesh* m2=NULL;
mesh* moriginal;

int ed;

//GLfloat ambient[] = { 0.0, 0.0, 0.0, 1.0 };
//GLfloat diffuse[] = { 1.0, 1.0, 1.0, 1.0 };
//GLfloat position[] = { 0.0, 10.0, 10.0, 0.0 };
//GLfloat lmodel_ambient[] = { 0.4, 0.4, 0.4, 1.0 };

typedef GLfloat (* func ) (GLfloat, GLfloat);

func myfunction;

int drawnormals;



void vectXMat(GLfloat* v, GLfloat* m, GLfloat* result)
{
  int i;
  int j;

        //prodotto vettore matrice
                for (i=0;i<4;i++)
                {
                        result[i]=0;
                        for (j=0;j<4;j++)
                        result[i]=result[i]+m[i+4*j]*v[j];
                }
};

void matXMat(GLfloat* m, GLfloat* m1, GLfloat* result)
{
  int i;
  int j;
  int t;
  for (i=0;i<4;i++)
    {
      for (j=0;j<4;j++)
        {
          result[4*i+j]=0;
          for (t=0;t<4;t++)
            result[4*i+j]=result[4*i+j]+m[4*i+t]*m1[4*t+j];
        }
    }
}

void identity(GLfloat* result)
{//riempie una matrice
       int i;
       int j;
       for (i=0;i<4;i++)
         {
        for (j=0;j<4;j++)
                if (i==j) result[4*i+j]=1; else result[4*i+j]=0;
        }
}

void rotateZ(GLfloat* m, GLfloat ang, GLfloat* result)
{
  int i;


  for (i=0;i<16 ; i++) matrix[i]=0;
  matrix[0]=cos(ang/180*3.1415);
  matrix[5]=cos(ang/180*3.1415);
  matrix[1]=-sin(ang/180*3.1415);
  matrix[4]=sin(ang/180*3.1415);
  matrix[10]=1;
  matrix[15]=1;
  matXMat(matrix,m,result);
}

void rotateY(GLfloat* m, GLfloat ang, GLfloat* result)
{
  int i;
  for (i=0;i<16 ; i++) matrix[i]=0;
  matrix[0]=cos(ang/180*3.1415);
  matrix[10]=cos(ang/180*3.1415);
  matrix[8]=-sin(ang/180*3.1415);
  matrix[2]=sin(ang/180*3.1415);
  matrix[5]=1;
  matrix[15]=1;
  matXMat(matrix,m,result);
}

void rotateX(GLfloat* m, GLfloat ang, GLfloat* result)
{
  int i;
  for (i=0;i<16 ; i++) matrix[i]=0;
  matrix[5]=cos(ang/180*3.1415);
  matrix[10]=cos(ang/180*3.1415);
  matrix[6]=-sin(ang/180*3.1415);
  matrix[9]=sin(ang/180*3.1415);
  matrix[0]=1;
  matrix[15]=1;
  matXMat(matrix,m,result);
}

void translate(GLfloat* m,GLfloat x ,GLfloat y ,GLfloat z, GLfloat* result)
{//matrix traslazione * m
  int i;
  for (i=0;i<16 ; i++) matrix[i]=0;
  matrix[0]=1;
  matrix[5]=1;
  matrix[10]=1;
  matrix[15]=1;
  matrix[12]=x;
  matrix[13]=y;
  matrix[14]=z;
  matXMat(matrix,m,result);
}



int round(GLfloat f)
{
  int i;
  GLfloat temp;
  temp=f-floor(f);
  if (temp<0.5) i=(int)floor(f); else i=(int)ceil(f);
  return (i);
}



void setLuce()
{
  luce0[0]=-7.0;
  luce0[1]=1.0;
  luce0[2]=10.0;
  luce0[3]=1.0;
  glLightfv(GL_LIGHT0,GL_POSITION,luce0);

}

GLfloat funzione2(GLfloat x,GLfloat y)
{
  return (tanh(9*y-9*x)+1)/9;
}

GLfloat funzione1(GLfloat x,GLfloat y)
{
  return
    3.0/4.0*(exp(-1.0/4*((9*x-2)*(9*x-2)+(9*y-2)*(9*y-2))))+
    3.0/4*(exp(-1.0/49*(9*x+1)*(9*x+1)-1.0/10*(9*y+1)))+
    1.0/2*(exp(-1.0/4*((9*x-7)*(9*x-7)+(9*y-3)*(9*y-3))))-
    1.0/5*(exp((-(9*x-4)*(9*x-4)-(9*y-7)*(9*y-7)))) ;

}

GLfloat funzione3(GLfloat x,GLfloat y)
{
  return (1.25+cos(5.4*y))/(6*(1+(3*x-1)*(3*x-1)));
}

GLfloat funzione4(GLfloat x,GLfloat y)
{
  return
    1.0/3*exp(-81/16.0*(((x-0.5)*(x-0.5)+(y-0.5)*(y-0.5))));
}

GLfloat funzione5(GLfloat x,GLfloat y)
{
  return
    1.0/3*exp(-81/4.0*(((x-0.5)*(x-0.5)+(y-0.5)*(y-0.5))));
}

GLfloat funzione6(GLfloat x,GLfloat y)
{
  return
    1.0/9*sqrt(64-81.0*(((x-0.5)*(x-0.5)+((y-0.5)*(y-0.5)))))-1/2.0;
}

GLfloat eps(GLfloat x)
{
  return 2.1*x-0.1;
}

GLfloat r(GLfloat e,GLfloat y)
{
  return sqrt( (e-1.5)*(e-1.5) + (y-0.5)*(y-0.5));
}

GLfloat funzione7(GLfloat x,GLfloat y)
{

  GLfloat t;
  t=y-eps(x);

  if (t>0.5) return 1;
  if (0<=t && t<=0.5) return 2*t;

  if (r(eps(x),y)<=0.25) return
                           0.5*cos(4*3.1415*(r(eps(x),y)))+
                           0.5;
  return 0;

}

GLfloat funzione8(GLfloat x,GLfloat y)
{

  return tanh(-3.0*(0.595576*(y+3.79762)*(y+3.79762)-x-10))+1.0;
}

GLfloat funzione9(GLfloat x,GLfloat y)
{

  return
    (1.0-x/2.0)*(1.0-x/2.0)*(1.0-x/2.0)*(1.0-x/2.0)*(1.0-x/2.0)*(1.0-x/2.0)*
    (1.0-y/2.0)*(1.0-y/2.0)*(1.0-y/2.0)*(1.0-y/2.0)*(1.0-y/2.0)*(1.0-y/2.0)+
    1000*(1.0-x)*(1.0-x)*(1.0-x)*x*x*x*
    (1.0-y)*(1.0-y)*(1.0-y)*y*y*y+
    y*y*y*y*y*y*(1.0-x/2.0)*(1.0-x/2.0)*(1.0-x/2.0)*(1.0-x/2.0)*(1.0-x/2.0)*(1.0-x/2.0)*
    x*x*x*x*x*x*(1.0-y/2.0)*(1.0-y/2.0)*(1.0-y/2.0)*(1.0-y/2.0)*(1.0-y/2.0)*(1.0-y/2.0);


}

GLfloat funzionec(GLfloat x,GLfloat y)
{
  return 1;
}

GLfloat funzione(GLfloat x,GLfloat y)
{
  return myfunction(x,y);
}

void normal(face& f,mesh* m)
{
  int l=f.iedge;
  f.nor=prod_vett(m->avertex[m->aedge[l].ipoint].ver,
		  m->avertex[m->aedge[EdgeNext(m,EdgeNext(m,l))].ipoint].ver, 
		  m->avertex[m->aedge[EdgeNext(m,l)].ipoint].ver);
  f.nor.normalize();
}

void normalconstr(face& f)
{
  int l=f.iedge;
  f.nor=prod_vett(m->avertex[m2->aedge[l].ipoint].ver,
		  m->avertex[m2->aedge[EdgeNext(m2,EdgeNext(m2,l))].ipoint].ver, 
		  m->avertex[m2->aedge[EdgeNext(m2,l)].ipoint].ver);
  f.nor.normalize();
}

mesh* refine(mesh* m)
{
  mesh* temp=new mesh;
  
  temp->nvertex=m->nvertex+m->nface;
  temp->nface=3*m->nface;
  temp->nedge=m->nedge+6*m->nface;

  temp->avertex=new vertexdraw[temp->nvertex];
  temp->aface=new face[temp->nface];
  temp->aedge=new hedge[temp->nedge];
  
  int e0,e1,e2;
  
  for (int i=0;i<m->nface;i++)
    {
      //copia facce
      e0=m->aface[i].iedge;
      e1=EdgeNext(m,e0);
      e2=EdgeNext(m,e1);
      temp->aface[3*i].iedge=e0;
      temp->aface[3*i+1].iedge=e1;
      temp->aface[3*i+2].iedge=e2;
      
      //nuovo vertice baricentrico
      temp->avertex[m->nvertex+i].ver=
	(m->avertex[m->aedge[e0].ipoint].ver+
	 m->avertex[m->aedge[e1].ipoint].ver+
	 m->avertex[m->aedge[e2].ipoint].ver)/3;
      
      //next face degli edge originali;
      
      temp->aedge[e0].inext=m->nedge+6*i+0;
      temp->aedge[e1].inext=m->nedge+6*i+1;
      temp->aedge[e2].inext=m->nedge+6*i+2;
      
      temp->aedge[e0].iface=3*i;
      temp->aedge[e1].iface=3*i+1;
      temp->aedge[e2].iface=3*i+2;
       
      temp->aedge[m->nedge+6*i].ipoint=m->aedge[e1].ipoint;
      temp->aedge[m->nedge+6*i+1].ipoint=m->aedge[e2].ipoint;
      temp->aedge[m->nedge+6*i+2].ipoint=m->aedge[e0].ipoint;
      temp->aedge[m->nedge+6*i+3].ipoint=m->nvertex+i;
      temp->aedge[m->nedge+6*i+4].ipoint=m->nvertex+i;
      temp->aedge[m->nedge+6*i+5].ipoint=m->nvertex+i;
      
      temp->aedge[m->nedge+6*i].inext=m->nedge+6*i+5;
      temp->aedge[m->nedge+6*i+1].inext=m->nedge+6*i+3;
      temp->aedge[m->nedge+6*i+2].inext=m->nedge+6*i+4;
      temp->aedge[m->nedge+6*i+3].inext=e1;
      temp->aedge[m->nedge+6*i+4].inext=e2;
      temp->aedge[m->nedge+6*i+5].inext=e0;
      
      temp->aedge[m->nedge+6*i].isibl=m->nedge+6*i+3;
      temp->aedge[m->nedge+6*i+1].isibl=m->nedge+6*i+4;
      temp->aedge[m->nedge+6*i+2].isibl=m->nedge+6*i+5;
      temp->aedge[m->nedge+6*i+3].isibl=m->nedge+6*i+0;
      temp->aedge[m->nedge+6*i+4].isibl=m->nedge+6*i+1;
      temp->aedge[m->nedge+6*i+5].isibl=m->nedge+6*i+2;

      temp->aedge[m->nedge+6*i].iface=3*i;
      temp->aedge[m->nedge+6*i+1].iface=3*i+1;
      temp->aedge[m->nedge+6*i+2].iface=3*i+2;
      temp->aedge[m->nedge+6*i+3].iface=3*i+1;
      temp->aedge[m->nedge+6*i+4].iface=3*i+2;
      temp->aedge[m->nedge+6*i+5].iface=3*i+0;

    }
  
  for (i=0;i<m->nvertex;i++)
    {//copia vertici
      temp->avertex[i]=m->avertex[i];
    }

  for (i=0;i<m->nedge;i++)
    {//copia vertici
      temp->aedge[i].ipoint=m->aedge[i].ipoint;
      temp->aedge[i].isibl=m->aedge[i].isibl;
    }

  //distrugge la vecchia mesh
  delete []m->aedge;
  delete []m->avertex;
  delete []m->aface;
  delete m;
  
  return temp;  
}







void updatepoints(void)
{
  for (int i=0;i<m->nvertex;i++)
    m->avertex[i].ver.z=myfunction(m->avertex[i].ver.x,m->avertex[i].ver.y);
  
  //calc normals
  for (int u=0;u<m->nface;u++)
    normal(m->aface[u],m);
  
  
  if (m2!=NULL)
    {
      //printf("%d\n",m2->nvertex);
      for (int i=0;i<m2->nvertex;i++)
      	{
      	  m->avertex[i].ver.z=myfunction(m->avertex[i].ver.x,m->avertex[i].ver.y);
      	}
      
      for (int u=0;u<m2->nface;u++)
	{
	  normalconstr(m2->aface[u]); 
	}
    }
  
  
  //update anche l'originale
  for (i=0;i<moriginal->nvertex;i++)
    moriginal->avertex[i].ver.z=myfunction(moriginal->avertex[i].ver.x,
					   moriginal->avertex[i].ver.y);
  
  //normali di faccia della triang originale
  for (int j=0;j<suddy;j++)
    for (i=0;i<suddx;i++)
      { 
	
	moriginal->aface[(i+j*suddx)*2].nor=
	      prod_vett(moriginal->avertex[i+j*(suddx+1)].ver,
			moriginal->avertex[i+1+j*(suddx+1)].ver,
			moriginal->avertex[i+(j+1)*(suddx+1)].ver);
	    moriginal->aface[(i+j*suddx)*2].nor.normalize();
	  
	    moriginal->aface[(i+j*suddx)*2+1].nor=
	      prod_vett(moriginal->avertex[i+(j+1)*(suddx+1)].ver,
			moriginal->avertex[i+j*(suddx+1)+1].ver,
			moriginal->avertex[i+1+(1+j)*(suddx+1)].ver);
	    moriginal->aface[(i+j*suddx)*2+1].nor.normalize();
	  
	  }
			
	//normali per bordi sup e inf
	for (int ct=0;ct<suddx;ct++)
	  {
	    moriginal->avertex[ct].nor=moriginal->aface[2*ct].nor;	    
	   }
	
	moriginal->avertex[suddx].nor=moriginal->aface[2*suddx-1].nor;	    
	   
	
	for (ct=0;ct<suddx;ct++)
	  {	    
	    moriginal->avertex[(suddx+1)*(suddy)+ct].nor=
	      moriginal->aface[2*(suddx*(suddy-1)+ct)+1].nor;
	  }

	 moriginal->avertex[(suddx+1)*(suddy)+suddx+1].nor=
	      moriginal->aface[2*(suddx*suddy)-1].nor;
	
	
	for (i=1;i<suddx;i++)
	  for (j=1;j<suddy;j++)
	    {
	      moriginal->avertex[i+j*(suddx+1)].nor=
		((2*moriginal->aface[2*(suddx*j+i)].nor+
		  moriginal->aface[2*(suddx*j+i)-1].nor+
		  moriginal->aface[2*((suddx*j+i)-suddx)].nor+
		  2*moriginal->aface[2*((suddx*j+i)-suddx)-1].nor+
		  moriginal->aface[2*((suddx*j+i)-suddx)+1].nor+
		  moriginal->aface[2*(suddx*j+i)-2].nor)/8);
	      
	      }
	
	for ( ct=0;ct<suddy;ct++)
	  {
	    moriginal->avertex[ct*(suddx+1)].nor=moriginal->aface[2*ct*suddx].nor;
	    moriginal->avertex[ct*(suddx+1)+suddx].nor=moriginal->aface[2*(ct*suddx+suddx-1)+1].nor;
	  }
	
	moriginal->avertex[(suddy+1)*(suddx+1)-1].nor=
	  moriginal->aface[2*(suddy*suddx)-1].nor;

}


mesh* meshoriginal(mesh* m)
{
  float xmin,xmax,ymin,ymax;

  
  mesh* temp;

  xmin=m->avertex[0].ver.x;
  xmax=m->avertex[0].ver.x;
  ymin=m->avertex[0].ver.y;
  ymax=m->avertex[0].ver.y;
  
  //trova rettangolo
  for (i=1;i<m->nvertex;i++)
    {
      if (xmin>m->avertex[i].ver.x) xmin=m->avertex[i].ver.x;
      if (xmax<m->avertex[i].ver.x) xmax=m->avertex[i].ver.x;
      if (ymin>m->avertex[i].ver.y) ymin=m->avertex[i].ver.y;
      if (ymax<m->avertex[i].ver.y) ymax=m->avertex[i].ver.y;
    }

  temp = new mesh;
  
  temp->nvertex = (suddx+1)*(1+suddy);
  temp->avertex = new vertexdraw[temp->nvertex];
  temp->aface = new face[suddx*suddy*2];
  
  for (j=0;j<suddy+1;j++)
    for (i=0;i<suddx+1;i++)
      {
	temp->avertex[i+j*(suddx+1)].ver.x=xmin+(xmax-xmin)/(suddx)*(i);
	temp->avertex[i+j*(suddx+1)].ver.y=ymin+(ymax-ymin)/(suddy)*(j);
      }
  
  
  for (j=0;i<suddy;j++)
    for (i=0;i<suddx;i++)
      { 
	
	temp->aface[(i+(j*suddx))*2].nor= 
	  prod_vett(temp->avertex[j*suddx+i+1].ver,
		    temp->avertex[j*suddx+i].ver,
		    temp->avertex[j*suddx+i+suddx].ver);
	temp->aface[(i+(j*suddx))*2].nor.normalize();
	
	temp->aface[(i+(j*suddx))*2+1].nor= 
	  prod_vett(temp->avertex[j*suddx+i+1].ver,
		    temp->avertex[j*suddx+i+suddx].ver,
		    temp->avertex[j*suddx+i+suddx+1].ver);
	temp->aface[(i+(j*suddx))*2+1].nor.normalize();
      }

  return temp;
}



void init(char* fv, char* ft,char* fc)
{
  datifile* df;
  datifile* df2;

  myfunction=funzione2;

  drawnormals=0;

  /* Attiva lo z-buffer */
  glEnable(GL_DEPTH_TEST);

  setLuce();

  glLightModeli(GL_LIGHT_MODEL_LOCAL_VIEWER,0);
  glEnable(GL_LIGHTING);
  glEnable(GL_LIGHT0);

  /* Matrice di proiezione */
  glMatrixMode(GL_PROJECTION);
  gluPerspective(40.0,1.333, 0.1,100.0);
  glMatrixMode(GL_MODELVIEW);
  gluLookAt(0.0, 0.0, 3.0,
            0.0, 0.0, 0.0,
            0.0, 1.0, 0.0);
  glClear (GL_COLOR_BUFFER_BIT);

  xtrasl=-0.5;
  ytrasl=-0.5;

  xrot=0;
  yrot=0;
  zrot=0;
  zoom=1;


  //  startx=0;
  //starty=0;

  //carica la matrice identita globale
  id = (GLfloat*)calloc(16,sizeof(GLfloat));
  identity(id);

  matrix=(GLfloat*)calloc(16,sizeof(GLfloat)); //temp per fare i conti
  rot=(GLfloat*)calloc(16,sizeof(GLfloat));
  rot1=(GLfloat*)calloc(16,sizeof(GLfloat));
  rot2=(GLfloat*)calloc(16,sizeof(GLfloat));
  rot3=(GLfloat*)calloc(16,sizeof(GLfloat));
  identity(rot);

  df=(loadmodel(fv,ft));  //carica da file
  if (fc!=NULL) df2=(loadmodel2(fc));

  printf("Structure loaded...\n");

  m=convert(df);   //converte i dati nella struttura mesh

  if (fc!=NULL) 
    m2=convert2(df2,m);
  else
    m2=NULL;

  printf("Structure converted...\n");

  //edge per la navigazione
  ed=0;

 
  //crea mesh originale
  suddx=100;
  suddy=100;
  moriginal=meshoriginal(m);
  updatepoints();
  
  printf("Init OK!\n");

}


void glmynormal3f(vertex v)
{  
  glNormal3f(v.x,v.y,v.z);
}


void glmyvertex3f(vertex v)
{
  glVertex3f(v.x,v.y,v.z);
}

void drawvertex(vertexdraw v)
{  
  glmynormal3f(v.nor);
  glmyvertex3f(v.ver);
}



void display(void)
{
  GLint u,ct;
  int l;

  vertex temp;
  
  GLfloat no_mat[] = { 0.0, 0.0, 0.0, 1.0 };
  GLfloat mat_ambient[] = { 0.5, 0.8, 0.5, 1.0 };
  GLfloat mat_ambient_color[] = { 0.0, 0.0, 0.6, 0.5 };
  GLfloat mat_diffuse[] = { 0.3, 0.4, 0.8, 0.5 };
  GLfloat rosso[] = { 1.0, 0.0, 0.0, 0.5 };
  GLfloat verde[] = { 0.0, 1.0, 0.0, 0.5 };
   GLfloat mat_specular[] = { 1.0, 1.0, 1.0, 0.8 };
   //GLfloat no_shininess[] = { 0.0 };
  GLfloat lo_shininess[] = { 5.0 };
  GLfloat hi_shininess[] = { 50.0 };
  //GLfloat mat_emission[] = {0.3, 0.2, 0.2, 0.0};
  
  
  setLuce();

  glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
  glPushMatrix();
  glTranslatef(xtrasl, ytrasl, -zoom);
  glMultMatrixf(rot);

  
  

  glEnable(GL_DEPTH_TEST);
  glEnable(GL_LIGHTING);

  
    //disegna funzione originale
    if (original>0)
      {
	
	glMaterialfv(GL_FRONT, GL_AMBIENT, mat_ambient);
	glMaterialfv(GL_FRONT, GL_DIFFUSE, rosso);
	glMaterialfv(GL_FRONT, GL_SPECULAR, mat_specular);
	glMaterialfv(GL_FRONT, GL_SHININESS, hi_shininess);
	glMaterialfv(GL_FRONT, GL_EMISSION, no_mat);
	

       
	for (int i=0;i<suddx;i++)	 
	for (int j=0;j<suddy;j++)
	  {

	    glBegin(GL_TRIANGLES);
	    drawvertex(moriginal->avertex[1+i+j*(suddx+1)]);
	    drawvertex(moriginal->avertex[i+j*(suddx+1)]);
	    drawvertex(moriginal->avertex[i+(j+1)*(suddx+1)]);
	    glEnd();
	    
	    glBegin(GL_TRIANGLES);
	    drawvertex(moriginal->avertex[1+i+j*(suddx+1)]);
	    drawvertex(moriginal->avertex[i+(j+1)*(suddx+1)]);
	    drawvertex(moriginal->avertex[1+i+(j+1)*(suddx+1)]);
	    glEnd();
	     
	  }

      } 


    glMaterialfv(GL_FRONT, GL_AMBIENT, mat_ambient);
    glMaterialfv(GL_FRONT, GL_DIFFUSE, mat_diffuse);
    glMaterialfv(GL_FRONT, GL_SPECULAR, mat_specular);
    glMaterialfv(GL_FRONT, GL_SHININESS, hi_shininess);
    glMaterialfv(GL_FRONT, GL_EMISSION, no_mat);
    
    if (original!=1)
      {
	if (original==2)
	  {
	    
	    glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
	    //GL_SRC_COLOR ,GL_DST_COLOR);
	    glEnable(GL_BLEND); 
	    
	  }
	
	
	for (u=0;u<m->nface;u++)
	  {
	    
	    l=m->aface[u].iedge;
	    glBegin(GL_TRIANGLES);
	    
	    //triangoli 3d
	    for (ct=0;ct<3;ct++)
	      {
		glmynormal3f(m->aface[u].nor);
		glmyvertex3f(m->avertex[m->aedge[l].ipoint].ver);
		l=EdgeNext(m,l);
	      }
	    glEnd();
	  }
	if (original==2)
	  glDisable(GL_BLEND);
      } 
  
  
    glDisable(GL_LIGHTING);
    if (drawnormals==1)
      {
	for (u=0;u<m->nface;u++)
	  {
	    l=m->aface[u].iedge;
	    
	    //normali
	    glColor3f(0.8,1,1);
	    
	    //baricentro
	    temp=((m->avertex[m->aedge[l].ipoint].ver+
		   m->avertex[m->aedge[EdgeNext(m,l)].ipoint].ver+
		   m->avertex[m->aedge[EdgeNext(m,EdgeNext(m,l))].ipoint].ver)/3);
	    
	    glBegin(GL_LINES);
	    glmyvertex3f(temp);
	    
	    glmyvertex3f(temp+m->aface[u].nor/20);
	    glEnd();
	  }
      }
    
    if (original!=1)
      {
	
	if (lines==0)
	  {
	    //linee bordi triangoli
	    glColor3f(0.0,0.2,0.1);
	    for (ct=0;ct<m->nedge;ct++)
	      {
		//triang in 3d
		glBegin(GL_LINE_STRIP);
		glVertex3f(m->avertex[m->aedge[ct].ipoint].ver.x,
			   m->avertex[m->aedge[ct].ipoint].ver.y,
			   m->avertex[m->aedge[ct].ipoint].ver.z+0.001);
		
		glVertex3f(m->avertex[m->aedge[EdgeNext(m,ct)].ipoint].ver.x,
			   m->avertex[m->aedge[EdgeNext(m,ct)].ipoint].ver.y,
			   m->avertex[m->aedge[EdgeNext(m,ct)].ipoint].ver.z+0.001);
		glEnd();
	      }
	  
	    
	    
	    glColor3f(0.8,0.8,0.8);
	    for (ct=0;ct<m->nedge;ct++)
	      {
		//proiezione 2d
		glBegin(GL_LINE_STRIP);
		glVertex3f(m->avertex[m->aedge[ct].ipoint].ver.x,m->avertex[m->aedge[ct].ipoint].ver.y,-0.001);
		glVertex3f(m->avertex[m->aedge[EdgeNext(m,ct)].ipoint].ver.x,
			   m->avertex[m->aedge[EdgeNext(m,ct)].ipoint].ver.y,
			   -0.001);
		glEnd();
	      }
	
	  }
      }

    
    //assi di riferimento
    glColor3f(1.0,1.0,1.0);
    glBegin(GL_LINE_STRIP);
    glVertex3f(0.,0.,0.);
    glVertex3f(0.,1.,0.);
    glVertex3f(1.,1.,0.);
    glVertex3f(1.,0.,0.);
    glVertex3f(0.,0.,0.);
    glVertex3f(0.,0.,1.);
    glEnd();
    
    
    
    //disegna constraints
    if (m2!=NULL && original!=1)
    {
      glEnable(GL_LIGHTING);
      glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
      //GL_SRC_COLOR ,GL_DST_COLOR);
      glEnable(GL_BLEND);
      
      glMaterialfv(GL_FRONT, GL_AMBIENT, no_mat);
      glMaterialfv(GL_FRONT, GL_DIFFUSE,  verde);
      glMaterialfv(GL_FRONT, GL_SPECULAR, mat_ambient_color);
      glMaterialfv(GL_FRONT, GL_SHININESS, lo_shininess);
      glMaterialfv(GL_FRONT, GL_EMISSION, no_mat);


      
      
      for (u=0;u<m2->nface;u++)
	{
	  l=m2->aface[u].iedge;
	  
	  glColor3f(1,0.5,1);
	  
	  glBegin(GL_TRIANGLES);
	  //triangoli 3d
	  for (ct=0;ct<3;ct++)
	    {
	      glmynormal3f(m2->aface[u].nor);
	      glmyvertex3f(m->avertex[m2->aedge[l].ipoint].ver);
	      l=EdgeNext(m2,l);
	    }
	  
	  glEnd();  
	}	
    }
    
    glDisable(GL_BLEND);
    
      
    
    glDisable(GL_DEPTH_TEST);
        if (original!=1)
      {

	
	//segmento temporaneo
	glColor4f(0.8,0.4,0.5,1.0);
	glBegin(GL_LINES);
	glmyvertex3f(m->avertex[m->aedge[ed].ipoint].ver);
	glmyvertex3f(m->avertex[m->aedge[EdgeNext(m,ed)].ipoint].ver);
	
	glEnd();
	
	/*
	//segmento temporaneo
	glColor3f(0.3,0.5,0.9);
	glBegin(GL_LINES);
	glVertex3f(m->avertex[m->aedge[ed].ipoint].ver.x,
		   m->avertex[m->aedge[ed].ipoint].ver.y,
		   0);
	glVertex3f(m->avertex[m->aedge[EdgeNext(m,ed)].ipoint].ver.x,
		   m->avertex[m->aedge[EdgeNext(m,ed)].ipoint].ver.y,
		   0);


	glEnd();

	*/
      }


   

    glPopMatrix();
    glutSwapBuffers();    
    
}






void idle(void)
{
}


void keyboard ( unsigned char key, GLint x , GLint y )
{
  double t;
  switch(key){
  case 27:
    exit (0);
    break;

  case 'd':
    xtrasl=xtrasl+0.1;
    break;
  case 'a':
    xtrasl=xtrasl-0.1;
    break;
  case 'w':
    ytrasl=ytrasl+0.1;
    break;
  case 's':
    ytrasl=ytrasl-0.1;
    break;
  case 'n': ed=EdgeNext(m,ed);
    /*    
    printf("Edge#          %d\n",ed);
    printf("Edge next#     %d\n",m->aedge[ed].inext);
    printf("Edge point#     %d\n",m->aedge[ed].ipoint);
     printf("Edge sibl#     %d\n",m->aedge[ed].isibl);
    printf("Edge face#     %d\n",m->aedge[ed].iface);
    printf("Edge face->edge%d\n",m->aface[m->aedge[ed].iface].iedge);
    */
    break;
  case 'N': 
    if (EdgeSibl(m,ed)!=-1) ed=EdgeSibl(m,ed);
    
    /*
      printf("Edge#          %d\n",ed);
    printf("Edge next#     %d\n",m->aedge[ed].inext);
    printf("Edge point#     %d\n",m->aedge[ed].ipoint);
    printf("Edge sibl#     %d\n",m->aedge[ed].isibl);
    printf("Edge face#     %d\n",m->aedge[ed].iface);
    printf("Edge face->edge%d\n",m->aface[m->aedge[ed].iface].iedge);
    */
    break;
    
  case 'z':
    m=refine(m);
    printf("New mesh: %d triangles\n",m->nface);
    updatepoints();
    break;

  case 'x':
    lines=1-lines;
    break;

  case 'u' :
    LOP(m, CrABNCriteria);
    updatepoints();
    break;
    
  case 'i' :
    LOP(m, CrJNDCriteria);
     updatepoints();
    break;
    
  case 'o' :
    LOP(m, CrDLPCriteria);
     updatepoints();
    break;
    
  case 'r':
    LOP_OneStep(m,ed,CrDoNothing);
     updatepoints();
    break;   
    
  case 't':
    LOP_OneStep(m,ed,CrABNCriteria);
     updatepoints();
    break;
    
  case '1' :
    myfunction=funzione1;
    updatepoints();
    break;
  case '2' :
    myfunction=funzione2;
    updatepoints();
    break;
  case '3' :
    myfunction=funzione3;
    updatepoints();
    break;
  case '4' :
    myfunction=funzione4;
    updatepoints();
    break;
  case '5' :
    myfunction=funzione5;
    updatepoints();
    break;
case '6' :
    myfunction=funzione6;
    updatepoints();
    break;
case '7' :
    myfunction=funzione7;
    updatepoints();
    break;
case '8' :
    myfunction=funzione8;
    updatepoints();
    break;
case '9' :
    myfunction=funzione9;
    updatepoints();
    break;
case '0' :
    myfunction=funzionec;
    updatepoints();
    break;
case 'p' :
  drawnormals=1-drawnormals;
  break;

case 'q' :
  original=(original+1)%3;
  break;

  case 'c':
    t=Integral(m, F1, myfunction);
    printf("\nIntegration results:");
    printf("\nF1: %f",t);
     t=Integral(m, F2, myfunction);
    printf("\nF2: %f",t);
     t=Integral(m, F3, myfunction);
    printf("\nF3: %f",t);
     t=Integral(m, F4, myfunction);
    printf("\nF4: %f",t);
    fflush(stdout);
    break;
    
  case '+':
    //delete [] moriginal->avertex;
    //delete [] moriginal->aface;
    delete moriginal;

    suddx+=10;
    suddy+=10;
    moriginal=meshoriginal(m); 
    printf("New mesh suddivision: %d\n",suddx);
    updatepoints();
    break;

case '-':
  //delete [] moriginal->avertex;
  //delete [] moriginal->aface;
  delete moriginal;
  
  suddx-=10;
  suddy-=10;
  printf("New mesh suddivision: %d\n",suddx);
  moriginal=meshoriginal(m);
  updatepoints();
  break;
  }
  
  glutPostRedisplay();
}






/* Movimento */
void motion(GLint x, GLint y)
{
  if (moving==1)
  {
    yrot=(startx-x)/1;
    xrot=(starty-y)/1;
    //porto il centro di rotazione nel baricentro

    translate(id,-.5,-.5,0,rot1);

    rotateY(id,yrot,rot3);

    matXMat(rot,rot1,rot2);

    rotateX(id,xrot,rot1);

    matXMat(rot2,rot1,rot);

    matXMat(rot,rot3,rot2);


    //riporto il centro di rotazione in pos. originale
    translate(id,+0.5,+0.5,-0,rot1);

    matXMat(rot2,rot1,rot);


    startx = x;
    starty = y;
    glutPostRedisplay();
  }

  if (moving==2)
  {
         zoom=zoom+(y-starty)/20.0;
    starty = y;
    glutPostRedisplay();

  }

  if (moving==3)
  {
    xtrasl=xtrasl+(x-startx)/100.0;
    ytrasl=ytrasl-(y-starty)/100.0;
    startx=x;
    starty=y;
    glutPostRedisplay();

  }
}

void mouse(GLint button, GLint state, GLint x, GLint y)
{
  if (button == GLUT_LEFT_BUTTON) {
    if (state == GLUT_DOWN) {
      moving = 1;
      startx = x;
      starty = y;
    }
    if (state == GLUT_UP) {
      startx = x;
      starty = y;
      moving = 0;
    }
  }
  if (button == GLUT_RIGHT_BUTTON) {
    if (state == GLUT_DOWN) {
      moving = 2;
      startx = x;
      starty = y;
    }
    if (state == GLUT_UP) {
      moving = 0;
    }
  }
  if (button == GLUT_MIDDLE_BUTTON) {
    if (state == GLUT_DOWN) {
      moving = 3;
      startx = x;
      starty = y;
    }
    if (state == GLUT_UP) {
      moving = 0;
    }

  }
  //glutPostRedisplay();
}


int main(GLint argc, char** argv)
{
  
  if (argc<3 || argc>4)
    {printf("\nUsage %s vertex-file triangles-file\n",argv[0]);
    exit(1);
    }

  glutInit(&argc,argv);
  glutInitDisplayMode ( GLUT_DOUBLE | GLUT_RGB | GLUT_DEPTH ) ;
  glutInitWindowSize(sizex,sizey);
  glutCreateWindow("Algoritmo LOP");

  if (argc==3)
    init(argv[1],argv[2],NULL);
  else
    init(argv[1],argv[2],argv[3]);
  
  glutKeyboardFunc(keyboard);
  glutIdleFunc(idle);
  glutDisplayFunc(display);
  glutMouseFunc(mouse);
  glutMotionFunc(motion);
  glutMainLoop();

  return 0;
}

