#include <stdio.h>
#include <fcntl.h>
#include <stdlib.h>

#define MAX_STAR 100

struct Xstar
{
  double x,y;
  int len;
  int star[MAX_STAR];
};

FILE* fin;
FILE* fv;
FILE* ft;

int nodes;
int ntri;

struct Xstar* model;

int ccV;

void read_triangulation(int _index)
{

  // returns number of valid triangles

  int j;
  int i=0;
  int flag=1;
  int t;
  int g;
  //int temp=0; //conta quanti triangoli hanno un vertice <i (gia' contati)

  do{
    fscanf(fin, "%d", &t);
    model[_index].star[i++] = t;
    //printf("%d\n", t);
    g=getc(fin);
    if(g=='\n')
      {
        flag = 0;
        //printf("OK\n\n");
      }
    else
      ungetc(g, fin);



  }while(flag);

  if(model[_index].star[i-1] == 0)
    i=i-2; //non chiude l'ultimo
  else
    model[_index].star[i] = model[_index].star[0];

  model[_index].len = i;

  //for (j=0;j<i;j++)
  //if (model[_index].star[j]>_index && model[_index].star[j+1]>_index)
  //temp++;

  //printf("%d\n",temp);
  //return (temp);
}

void readfile()
{
  char buf[255];
  int i = 1;
  int t[100];

  do
  {
        fscanf(fin, "%s", buf);
        /*
                Mantenere commentata serve solo per DEBUG
                      printf("%s\n", buf);
        */
        if (!strcmp(buf, "adjacency"))
            i = 0;
  }while(i);

  // Siamo posizionati sulla riga adjacency sets = ....

  fscanf(fin," sets,    n = %5d",&nodes);
  printf("I vertici sono =  %d\n",nodes);

  // Legge la seguente riga :
  // node     x(node)        y(node)                    neighbors of node
  fscanf(fin,"%s %s %s %s %s %s\n",buf, buf, buf, buf, buf, buf);

  model = malloc(sizeof(struct Xstar)*nodes);
  if(model==NULL)
  {
     printf("Errore memoria insufficiente\n");
     exit(0);
  }

  ntri=0;

  for(i=0;i<nodes;i++)
  {
      fscanf(fin, "%d %lf %lf", &t[0], &model[i].x, &model[i].y);
      printf("\n%d %lf %lf\n",t[0], model[i].x, model[i].y);
      read_triangulation(i);
  }

  i = 1;
  do
  {
        fscanf(fin, "%s", buf);
	//printf("%s\n",buf);
        /*
                Mantenere commentata serve solo per DEBUG
                      printf("%s\n", buf);
        */
        if (!strcmp(buf, "curves"))
            i = 0;
  }while(i);

  fscanf(fin,"%d",&ccV);

}


void writefile()
{
  //write vertex
  int i;
  int j;
  int con = 0;

  fprintf(fv,"%d\n",nodes);
  fprintf(ft,"               \n");
  for (i=0; i<nodes;i++)
    fprintf(fv,"%lf %lf\n",model[i].x, model[i].y);

  for (i=0; i<nodes;i++)
    {
      for (j=0; j<model[i].len;j++)
        {

          if ((model[i].star[j]>i+1 && model[i].star[j+1]>i+1) &&
	      (!(model[i].star[j]>=ccV && model[i].star[j+1]>=ccV && i+1>=ccV)))
            {
	      fprintf(ft,"%d %d %d\n",i,model[i].star[j+1]-1,model[i].star[j]-1);
	      con++;
	    }
        }
    }
  fseek(ft, 0, SEEK_SET);
  fprintf(ft,"%d",con);
}


void main(int argc, char* argv[])
{
  if (argc!=4)
    {
      printf("Usage: %s tripack-output vertex-file triangles-file\n",argv[0]);
      exit(0);
    }

  fin=fopen(argv[1],"r");
  if (fin==NULL)
    {
      printf("File error: %s\n",argv[1]);
      exit(0);
    }

  fv=fopen(argv[2],"w+");
  if (fv==NULL)
    {
      printf("File error: %s\n",argv[2]);
      exit(0);
    }

  ft=fopen(argv[3],"w+");
  if (ft==NULL)
    {
      printf("File error: %s\n",argv[3]);
      exit(0);
    }


  readfile();

  writefile();


  fclose(fin);
  fclose(fv);
  fclose(ft);

}
