#include "triio.h"
#include <GL/glut.h>
#include <stdio.h>
#include <stdlib.h>

datifile* loadmodel(char* fv,char* ft)
{
  int nv, nf;
  int i;
  int a, b, c;
  GLfloat x, y;
  FILE *file;

  datifile * m;


  //carica i punti

  file = fopen(fv,"r");
  if (file==NULL) {printf("Errore nel file!");exit(1);}


  m=(datifile*)(malloc(sizeof(datifile)));
  printf("Lettura header \n");
  fscanf(file, "%d\n", &nv);
  m->nvertici = nv;
  m->vertici=(vertex*)(calloc(nv+1,(sizeof(vertex))));

  printf("Lettura %d vertici \n", nv);
  for(i=0;i<nv;i++)
    {
      fscanf(file, "%f %f", &x, &y);
      m->vertici[i].x = x;
      m->vertici[i].y = y;
      m->vertici[i].z = 0;//funzionec (x,y);
      printf("%f %f %f %d\n",x,y,m->vertici[i].z,i);
    }

  fclose(file);




  //carica i triangoli di delaunay

  file = fopen(ft,"r");
  if (file==NULL) {printf("Errore nel file!");exit(1);}

  fscanf(file, "%d\n", &nf);
  m->ntriangoli=nf;
  m->facciafile=(trifile*)(calloc(nf+1,(sizeof(trifile))));
  printf("Lettura %d triangoli", nf);
  for(i=0;i<nf;i++)
    {
      fscanf(file, "%d %d %d", &a, &b, &c);
      m->facciafile[i].v[0] = a;
      m->facciafile[i].v[1] = b;
      m->facciafile[i].v[2] = c;
    }
  printf(" \n");
fclose(file);

return(m);
}



datifile* loadmodel2(char* fc)
{
  int nf;
  int i;
  int a, b, c;
  //GLfloat x, y;
  FILE *file;

  datifile * m;


  //carica solo triangoli

  file = fopen(fc,"r");
  if (file==NULL) {printf("Errore nel file!");exit(1);}


  m=(datifile*)(malloc(sizeof(datifile)));
  //carica i triangoli di delaunay

  file = fopen(fc,"r");
  if (file==NULL) {printf("Errore nel file!");exit(1);}

  fscanf(file, "%d\n", &nf);
  m->ntriangoli=nf;
  m->facciafile=(trifile*)(calloc(nf+1,(sizeof(trifile))));
  printf("Lettura %d triangoli", nf);
  for(i=0;i<nf;i++)
    {
      fscanf(file, "%d %d %d", &a, &b, &c);
      m->facciafile[i].v[0] = a;
      m->facciafile[i].v[1] = b;
      m->facciafile[i].v[2] = c;     
    }
  printf(" \n");
fclose(file);

return(m);
}



int cercaGemello(datifile* mf,int b,int a)
{
  int     temp=-1;
  int i;
  int j;

  for (i=0; temp==-1 && i<mf->ntriangoli; i++)
    {

      for (j=0; j<3;j++) // per ogni faccia creiamo i 3 half lati
        {

          if ((mf->facciafile[i].v[j]==a) && (mf->facciafile[i].v[(j+1)%3]==b))
            temp=3*i+j;
        }
    }
  return(temp);
}

mesh* convert(datifile* mf)
{
  int f;
  mesh* m= new mesh;
  if (m==NULL) {printf("Convert: Not enough memory...\n");exit(0);}

  m->nvertex = mf->nvertici;
  m->nface = mf->ntriangoli;
  m->nedge = mf->ntriangoli*3;

  m->avertex=new vertexdraw[m->nvertex];
  if (m->avertex==NULL) {printf("Convert: Not enough memory...\n");exit(0);}
  m->aface=new face[m->nface];
  if (m->aface==NULL) {printf("Convert: Not enough memory...\n");exit(0);}  
  m->aedge=new hedge[m->nedge];
  if (m->aedge==NULL) {printf("Convert: Not enough memory...\n");exit(0);}



  for (int i=0;i<mf->nvertici;i++) //copio i vertici
    {
      m->avertex[i].ver=mf->vertici[i];
    }
  //      m->vertici[i].me=i;
  

  printf("N. tri %d\n",mf->ntriangoli);
  for (i=0;i<mf->ntriangoli;i++) // per ogni faccia creiamo i 3 half lati
    {
      for (int j=0; j<3;j++) // per ogni faccia creiamo i 3 half lati
        {


	  //printf("Triangolo %d punto %d vertice %d\n",i,j,mf->facciafile[i].v[j]);
          m->aedge[3*i+j].ipoint=mf->facciafile[i].v[j];
          m->aedge[3*i+j].inext=(j+1)%3+3*i;

          f=cercaGemello(mf,mf->facciafile[i].v[j],mf->facciafile[i].v[(j+1)%3]);

          // cerchiamo il gemello del lato
          if (f==-1)
            m->aedge[3*i+j].isibl=-1;
          else
            m->aedge[3*i+j].isibl=f;
	  
          m->aedge[3*i+j].iface=i;

        }
      
      m->aface[i].iedge=3*i;

      //printf("faccia %d punta a edge %d\n",i,3*i);
    }


  /*
  //aggiorna i riferimenti all'array
  for (i=0;i<m->nface;i++)
    {
      m->facce[i].me=i;
    }

  for (i=0;i<m->nlati;i++)
    {
      m->lati[i].me=i;
      //printf("%f\n",m->lati[i].point->z);
    }
  */

  return(m);
}



mesh* convert2(datifile* mf,mesh* mo)
{
  int f;
  mesh* m=new mesh;
  if (m==NULL) {printf("Convert: Not enough memory...\n");exit(0);}

  m->nface = mf->ntriangoli;
  m->nedge = mf->ntriangoli*3;
  m->nvertex = mo->nvertex;

  
  m->aface=new face[m->nface];
  if (m->aface==NULL) {printf("Convert: Not enough memory...\n");exit(0);}  
  m->aedge=new hedge[m->nedge];
  if (m->aedge==NULL) {printf("Convert: Not enough memory...\n");exit(0);}
  
  //m->avertex=new vertexdraw[mo->nvertex];
  //if (m->avertex==NULL) {printf("Convert: Not enough memory...\n");exit(0);}

  //for (f=0;f<m->nvertex;f++)
  //  m->avertex[f]=mo->avertex[f];


  printf("N. tri %d\n",mf->ntriangoli);
  for (int i=0;i<mf->ntriangoli;i++) // per ogni faccia creiamo i 3 half lati
    {
      for (int j=0; j<3;j++) // per ogni faccia creiamo i 3 half lati
        {


	  //printf("Triangolo %d punto %d vertice %d\n",i,j,mf->facciafile[i].v[j]);
          m->aedge[3*i+j].ipoint=mf->facciafile[i].v[j];
          m->aedge[3*i+j].inext=(j+1)%3+3*i;

          f=cercaGemello(mf,mf->facciafile[i].v[j],mf->facciafile[i].v[(j+1)%3]);

          // cerchiamo il gemello del lato
          if (f==-1)
            m->aedge[3*i+j].isibl=-1;
          else
            m->aedge[3*i+j].isibl=f;
	  
          m->aedge[3*i+j].iface=i;

        }
      
      m->aface[i].iedge=3*i;


      //printf("faccia %d punta a edge %d\n",i,3*i);
    }

  return(m);
}







