
#ifndef _B_VERTEX_H

#define _B_VERTEX_H

#include <math.h>
//#include <iostream.h>

typedef float ttype;

//template<class ttype>
class tvertex
{
        public:
                /*union {
                        struct { ttype x; ttype y; ttype z; };
                        ttype v[3];
                };*/

                ttype x, y, z;


                tvertex(ttype _x = 0.0, ttype _y = 0.0, ttype _z = 0.0) : x(_x), y(_y), z(_z)
                {
                        //cout << "New Obj : " << this << "\n";
                }

                virtual ~tvertex()
                {
                        //cout << "Destroy Obj : " << this  << "\n";
                }

                tvertex(const tvertex& _v)
                {
                        x = _v.x;
                        y = _v.y;
                        z = _v.z;

                        //cout << "Copy Construct Obj : " << this  << "\n";
                }

                tvertex& operator =(const tvertex& _v)
                {
                        x = _v.x;
                        y = _v.y;
                        z = _v.z;
			return *this;
                        //cout << "Operator = Obj : " << this  << "   "<< &_v << "\n";
                }

                friend tvertex operator +(const tvertex& _v1, const tvertex& _v2)
                {
                        return tvertex(_v1.x + _v2.x, _v1.y + _v2.y, _v1.z + _v2.z);
                }

                friend tvertex operator -(const tvertex& _v1, const tvertex& _v2)
                {
                        return tvertex(_v1.x - _v2.x, _v1.y - _v2.y, _v1.z - _v2.z);
                }

                friend tvertex prod_vett(const tvertex& _v1, const tvertex& _v2)
                {
                        return tvertex(_v1.y*_v2.z - _v2.y*_v1.z,
                                                  _v1.z*_v2.x - _v2.z*_v1.x,
                                                  _v1.x*_v2.y - _v2.x*_v1.y);
                }
		
		friend tvertex prod_vett(const tvertex& _v1, const tvertex& _v2, const tvertex& _v3)
                {
		  return prod_vett(_v1-_v2,_v1-_v3);

                }


                friend double operator *(const tvertex& _v1, const tvertex& _v2)
                {
                        return _v1.x * _v2.x + _v1.y * _v2.y + _v1.z * _v2.z;
                }

                friend tvertex operator /(const tvertex& _v1, double _val)
                {
                        return tvertex(_v1.x/_val,
                                                  _v1.y/_val,
                                                  _v1.z/_val);
                }

                friend tvertex operator /(double _val,const tvertex& _v1)
                {
                        return tvertex(_val/_v1.x,
                                                  _val/_v1.y,
                                                  _val/_v1.z);
                }

                friend tvertex operator *(const tvertex& _v1, double _val)
                {
                        return tvertex(_v1.x*_val,
                                                  _v1.y*_val,
                                                  _v1.z*_val);
                }

                friend tvertex operator *(double _val, const tvertex& _v1)
                {
                        return tvertex(_v1.x*_val,
                                                  _v1.y*_val,
                                                  _v1.z*_val);
                }

                tvertex& normalize()
                {
                        
			double n = sqrt(*this * *this);
                        //*this = *this/n;
                        x = x / n;
                        y = y / n;
                        z = z / n;
                        return *this;
                }
};

#endif











